package com.vendor.loader.util.ssu;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Log.Log;
import com.vendor.loader.Messages;
import com.vendor.loader.controler.Builder;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.struct.CableMode;
import com.vendor.loader.struct.DbFrontEnd;
import com.vendor.loader.struct.HeadTsPacket;
import com.vendor.loader.struct.PartFile;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.struct.UpgradeInfo;
import com.vendor.loader.struct.ssu.CompatibilityDescriptor;
import com.vendor.loader.struct.ssu.DDBSections;
import com.vendor.loader.struct.ssu.DSMCCMessageHeader;
import com.vendor.loader.struct.ssu.DSMCCSectionHead;
import com.vendor.loader.struct.ssu.DSMCC_SectionInfo;
import com.vendor.loader.struct.ssu.GroupDescription;
import com.vendor.loader.struct.ssu.GroupInfoIndication;
import com.vendor.loader.struct.ssu.ModuleDescription;
import com.vendor.loader.struct.ssu.SsuUpgradeInfo;
import com.vendor.loader.struct.ssu.SubCompatibilityDescriptor;
import com.vendor.loader.util.Crc32;
import com.vendor.loader.util.FileHelper;
import com.vendor.loader.util.FileUtil;
import com.vendor.loader.util.LoaderException;
import com.vendor.loader.util.PropertiesUtility;
import com.vendor.loader.util.RandomFileOutputStream;
import com.vendor.loader.util.StringUtil;
import com.vendor.loader.util.ssu.SsuPackageOptions;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.SubProgressMonitor;
import org.eclipse.ui.WorkbenchEncoding;

public class SsuTsPackageBuilder implements Builder {
  public static final String UPGRADE_FILE_NAME = "packer.ts";
  
  private static final int SIZE_OF_U16 = 2;
  
  public static final int MAGICNUM_SIZE = 4;
  
  private static long g_u32DataTotalLen = 0L;
  
  private static int g_u32DataCrc = 0;
  
  private static int g_u32GroupId;
  
  public static int getG_u32GroupId() {
    return g_u32GroupId;
  }
  
  public static void setG_u32GroupId(int g_u32GroupId) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_u32GroupId = g_u32GroupId;
  }
  
  private static long g_softwareVersion = 16843009L;
  
  public static long getG_softwareVersion() {
    return g_softwareVersion;
  }
  
  public static void setG_softwareVersion(long g_softwareVersion) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_softwareVersion = g_softwareVersion;
  }
  
  private static long g_FactoryIdFlag = 3L;
  
  public static long getG_FactoryIdFlag() {
    return g_FactoryIdFlag;
  }
  
  public static void setG_FactoryIdFlag(long g_FactoryIdFlag) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_FactoryIdFlag = g_FactoryIdFlag;
  }
  
  private static long g_HardwareVersion = 1L;
  
  public static long getG_HardwareVersion() {
    return g_HardwareVersion;
  }
  
  public static void setG_HardwareVersion(long g_HardwareVersion) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_HardwareVersion = g_HardwareVersion;
  }
  
  private static long g_start_sn = 0L;
  
  public static long getG_start_sn() {
    return g_start_sn;
  }
  
  public static void setG_start_sn(long g_start_sn) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_start_sn = g_start_sn;
  }
  
  private static long g_end_sn = -1L;
  
  public static long getG_end_sn() {
    return g_end_sn;
  }
  
  public static void setG_end_sn(long g_end_sn) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_end_sn = g_end_sn;
  }
  
  private static long g_download_date = 537460993L;
  
  private int count = 0;
  
  private int countNIT = 0;
  
  private int countBAT = 0;
  
  private static DbFrontEnd g_struFrontend;
  
  private static List<PartFile> g_struPartFile;
  
  private static short g_ulPartNum;
  
  private double symbolRate;
  
  private int validSymbolRate;
  
  private int transferMode;
  
  private int sectionNumber;
  
  public static DbFrontEnd getG_struFrontend() {
    return g_struFrontend;
  }
  
  public static void setG_struFrontend(DbFrontEnd g_struFrontend) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_struFrontend = g_struFrontend;
  }
  
  public static List<PartFile> getG_struPartFile() {
    return g_struPartFile;
  }
  
  public static void setG_struPartFile(List<PartFile> g_struPartFile) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_struPartFile = g_struPartFile;
  }
  
  public static short getG_ulPartNum() {
    return g_ulPartNum;
  }
  
  public static void setG_ulPartNum(int g_ulPartNum) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.g_ulPartNum = (short)g_ulPartNum;
  }
  
  private byte[] tempByte = new byte[6144];
  
  private static boolean is32Bit;
  
  private static boolean is64Bit;
  
  public static boolean isIs32Bit() {
    return is32Bit;
  }
  
  public static void setIs32Bit(boolean is32Bit) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.is32Bit = is32Bit;
  }
  
  public static boolean is64Bit() {
    return is64Bit;
  }
  
  public static void set64Bit(boolean is64Bit) {
    com.vendor.loader.util.ssu.SsuTsPackageBuilder.is64Bit = is64Bit;
  }
  
  public IStatus createPackageOptions(List<UpgradeFileInfo> list, SsuUpgradeInfo info, SsuPackageOptions packageOtions, String strFilePathName, IProgressMonitor monitor) throws IOException, LoaderException {
    boolean oneBATNAT = true;
    monitor.setTaskName("Validate upgrade file list..");
    boolean success = FileHelper.validateUpdateFilesList(list, 251658240L);
    if (!success)
      return Status.CANCEL_STATUS; 
    monitor.setTaskName("Analysis of the part file");
    List<UpgradeFileInfo> realInfoList = FileHelper.getRealBurnFileList(list, 251658240L);
    if (256 < realInfoList.size())
      throw new LoaderException(String.format(Messages.LoaderComposite_MaxPartFile, new Object[] { Integer.valueOf(256) })); 
    monitor.beginTask("Packaged part files", 100 * realInfoList
        .size() + 20 + 20);
    setG_softwareVersion(info.getSoftwareVersion());
    setG_FactoryIdFlag(info.getManufacturerId());
    setG_HardwareVersion(info.getHardwareVersion());
    setG_start_sn(info.getStartSn());
    setG_end_sn(info.getEndSn());
    setG_struFrontend(new DbFrontEnd());
    getG_struFrontend().setU32Frequency(674000);
    getG_struFrontend().setU32SymbolRate(6875000);
    getG_struFrontend().setEnModulation(CableMode.valueOf(2));
    getG_struFrontend().setU16TsPID((short)info.getDownloadPid());
    getG_struFrontend().setU16GroupID((short)info.getDownloadGroupId());
    setG_u32GroupId(getG_struFrontend().getU16GroupID());
    monitor.worked(5);
    byte[] tsBuf = new byte[184];
    int lenDatagram = 0, lenPartInfo = 0, lenDownloadCtrl = 0;
    int pTempOffset = 0;
    HeadTsPacket strHeadTsPak = new HeadTsPacket();
    DSMCC_SectionInfo stDSISection = new DSMCC_SectionInfo();
    DSMCC_SectionInfo stDIISection = new DSMCC_SectionInfo();
    DSMCC_SectionInfo stNULLSection = new DSMCC_SectionInfo();
    construct_NULLSection(stNULLSection);
    DSMCC_SectionInfo stNITSection = new DSMCC_SectionInfo();
    DSMCC_SectionInfo stBATSection = new DSMCC_SectionInfo();
    int dataGramIndex = 0;
    strHeadTsPak.setSynByte((byte)71);
    strHeadTsPak.setTransportErrorIndicator1((byte)0);
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    strHeadTsPak.setTransportPriority1((byte)0);
    strHeadTsPak.setTransportScramblingControl2((byte)0);
    strHeadTsPak.setAdaptationFieldControl2((byte)1);
    Arrays.fill(tsBuf, (byte)-1);
    RandomFileOutputStream fp = newOutputStream(strFilePathName);
    if (fp == null)
      return Status.CANCEL_STATUS; 
    byte[] nit = null;
    int nitLength = 0;
    byte[] bat = null;
    int batLength = 0;
    try {
      monitor.worked(5);
      monitor.setTaskName("Compute all of part file crc");
      setG_struPartFile(fillFileDataStruct(realInfoList));
      setG_ulPartNum(getG_struPartFile().size());
      monitor.setTaskName("Package Part file..");
      monitor.worked(10);
      for (int partIndex = 0; partIndex < getG_ulPartNum(); partIndex++) {
        if (monitor.isCanceled())
          return Status.CANCEL_STATUS; 
        PartFile partFile = getG_struPartFile().get(partIndex);
        long[] values = { partFile.getSectionNum(), partFile.getLastDiagramDataLength(), partFile.getDatagramNum() };
        strHeadTsPak.setPid13(getG_struFrontend().getU16TsPID());
        monitor.worked(20);
        long u16DataGramNum = values[0];
        SubProgressMonitor subProgressMonitor = null;
      } 
      if (nit != null && bat != null && packageOtions != null) {
        boolean needInsertLinkedDesc = (packageOtions.getInsertLinkedDescriptorBtn() && nit.length > 0 && bat.length > 0);
        if (needInsertLinkedDesc)
          WriteTextFile(strFilePathName, nit, nitLength, bat, batLength); 
      } 
    } finally {
      monitor.worked(20);
      try {
        fp.close();
      } catch (IOException e) {
        throw new LoaderException(Messages.TsPackageBuilder_CreateError);
      } 
    } 
    return Status.OK_STATUS;
  }
  
  private IStatus insertEmptyPacket(SsuPackageOptions packageOtions, IProgressMonitor monitor, byte[] tsBuf, int pTempOffset, HeadTsPacket strHeadTsPak, DSMCC_SectionInfo stNULLSection, RandomFileOutputStream fp, SubProgressMonitor subProgressMonitor, int lenPartInfo, byte[] pTmp) throws LoaderException, IOException {
    boolean neenInsertEmptyPacket = (packageOtions.getInsertEmptyPacket() && this.symbolRate > this.validSymbolRate && this.validSymbolRate > 0);
    if (neenInsertEmptyPacket) {
      int number = (int)((this.symbolRate - this.validSymbolRate) / 1000.0D * 3060.0D / this.sectionNumber) * 2;
      if (monitor.isCanceled())
        return Status.CANCEL_STATUS; 
      if (number < 0)
        number = 2; 
      int tempNumber = number * 184;
      int size = (int)(tempNumber / 4066L);
      if (tempNumber % 4066L != 0L)
        size++; 
      pTmp = stNULLSection.getpSectionBuff();
      lenPartInfo = stNULLSection.getBuffLength();
      for (int i = 0; i < size; i++) {
        if (i + 1 == size)
          lenPartInfo = (int)(tempNumber - 4066L * i); 
        if (monitor.isCanceled())
          return Status.CANCEL_STATUS; 
        Arrays.fill(this.tempByte, (byte)-1);
        strHeadTsPak.setPid13((short)8191);
        int[] tempNullNumber = fillTsPackage(this.tempByte, strHeadTsPak, pTmp, pTempOffset, lenPartInfo, 0, tsBuf);
        int nullLen = tempNullNumber[1];
        if (nullLen > 0) {
          try {
            fp.write(this.tempByte, 0, nullLen);
          } catch (IOException e) {
            closeStream(fp);
            throw new LoaderException(Messages.TsPackageBuilder_CreateError);
          } 
          fflush(fp);
        } 
      } 
      strHeadTsPak.setPid13(getG_struFrontend().getU16TsPID());
    } 
    subProgressMonitor.worked(1);
    return Status.OK_STATUS;
  }
  
  private void WriteTextFile(String strFilePathName, byte[] nit, int nitLength, byte[] bat, int batLength) {
    if (strFilePathName == null)
      return; 
    String fileName = strFilePathName;
    if (strFilePathName.lastIndexOf('.') > 0) {
      fileName = strFilePathName.substring(0, strFilePathName
          .lastIndexOf('.'));
      fileName = fileName + "PSI-SI.txt";
    } else {
      fileName = fileName + "PSI-SI.txt";
    } 
    if (fileName != null && !fileName.isEmpty()) {
      StringBuffer resultNIT = new StringBuffer();
      resultNIT.append("NIT:\n\tsection:0\n");
      resultNIT.append("\t\ttable_id0x40\n");
      resultNIT.append("\t\tsection_syntax_indicator0x01\n");
      resultNIT.append("\t\tsection_length(byte):0x");
      resultNIT.append(Integer.toHexString(nit[3]));
      resultNIT.append("(");
      resultNIT.append(nit[3]);
      resultNIT.append(")\n");
      resultNIT.append("\t\tnetwork_id:");
      resultNIT.append("0x0001");
      resultNIT.append("\n");
      resultNIT.append("\t\tversion_number:");
      resultNIT.append("0x00");
      resultNIT.append("\n");
      resultNIT.append("\t\tcurrent_next_indicator:");
      resultNIT.append("0x1");
      resultNIT.append("\n");
      resultNIT.append("\t\tsection_number:");
      resultNIT.append("0x00(0)");
      resultNIT.append("\n");
      resultNIT.append("\t\tlast_section_number:");
      resultNIT.append("0x00(0)");
      resultNIT.append("\n");
      resultNIT.append("\t\tnetwork_descriptors_length(byte):");
      resultNIT.append("0x");
      resultNIT.append(Integer.toHexString(nit[10]));
      resultNIT.append("(");
      resultNIT.append(nit[10]);
      resultNIT.append(")");
      resultNIT.append("\n");
      resultNIT.append("\t\tnetwork_descriptors:");
      resultNIT.append("\n");
      resultNIT.append("\t\t\tdescriptor_tag:0x");
      resultNIT.append(Integer.toHexString(nit[11]));
      resultNIT.append("(");
      resultNIT.append(nit[11]);
      resultNIT.append(")");
      resultNIT.append("\n");
      resultNIT.append("\t\t\tdescriptor_length(byte):0x");
      resultNIT.append(Integer.toHexString(nit[12]));
      resultNIT.append("(");
      resultNIT.append(nit[12]);
      resultNIT.append(")");
      resultNIT.append("\n");
      resultNIT.append("\t\t\ttransport_stream_id:");
      resultNIT.append("0x0001");
      resultNIT.append("\n");
      resultNIT.append("\t\t\toriginal_network_id:");
      resultNIT.append("0x0001");
      resultNIT.append("\n");
      resultNIT.append("\t\t\tservice_id:");
      resultNIT.append("0x0001");
      resultNIT.append("\n");
      resultNIT.append("\t\t\tlinkage_type:");
      resultNIT.append("0x");
      resultNIT.append(Integer.toHexString(nit[19]));
      resultNIT.append("\n");
      resultNIT.append("\t\t\toui_data_length(byte):");
      resultNIT.append("0x");
      resultNIT.append(Integer.toHexString(nit[21]) + "(" + Integer.toHexString(nit[21]) + ")\n");
      StringBuffer buf = new StringBuffer();
      for (int i = 1; i < nit[21] + 1; i++)
        buf.append(StringUtil.toHexStr(nit[21 + i], 2) + " "); 
      resultNIT.append("\t\t\toui_data(hex):" + buf.toString() + "\n");
      resultNIT.append("\t\ttransport_stream_loop_length:0x");
      resultNIT.append(StringUtil.toHexStr(nit[70], 2) + "(" + StringUtil.toHexStr(nit[70], 2) + ")");
      resultNIT.append("\n");
      resultNIT.append("\t\tcrc_32:0x");
      resultNIT.append(StringUtil.toHexStr(nit[72], 2));
      resultNIT.append(StringUtil.toHexStr(nit[73], 2));
      resultNIT.append(StringUtil.toHexStr(nit[74], 2));
      resultNIT.append(StringUtil.toHexStr(nit[75], 2) + "\n\n");
      StringBuffer resultBAT = new StringBuffer();
      resultBAT.append("BAT:\n\tsection:0\n");
      resultBAT.append("\t\ttable_id0x4a\n");
      resultBAT.append("\t\tsection_syntax_indicator0x01\n");
      resultBAT.append("\t\tsection_length(byte):0x");
      resultBAT.append(Integer.toHexString(bat[3]));
      resultBAT.append("(");
      resultBAT.append(bat[3]);
      resultBAT.append(")\n");
      resultBAT.append("\t\tbouquet_id:");
      resultBAT.append("0x0000");
      resultBAT.append("\n");
      resultBAT.append("\t\tversion_number:");
      resultBAT.append("0x00");
      resultBAT.append("\n");
      resultBAT.append("\t\tcurrent_next_indicator:");
      resultBAT.append("0x0");
      resultBAT.append("\n");
      resultBAT.append("\t\tsection_number:");
      resultBAT.append("0x00(0)");
      resultBAT.append("\n");
      resultBAT.append("\t\tlast_section_number:");
      resultBAT.append("0x00(0)");
      resultBAT.append("\n");
      resultBAT.append("\t\tbouquet_descriptors_length(byte):");
      resultBAT.append("0x");
      resultBAT.append(Integer.toHexString(bat[10]));
      resultBAT.append("(");
      resultBAT.append(bat[10]);
      resultBAT.append(")");
      resultBAT.append("\n");
      resultBAT.append("\t\tbouquet_descriptors:");
      resultBAT.append("\n");
      resultBAT.append("\t\t\tdescriptor_tag:0x");
      resultBAT.append(Integer.toHexString(bat[11]));
      resultBAT.append("(");
      resultBAT.append(bat[11]);
      resultBAT.append(")");
      resultBAT.append("\n");
      resultBAT.append("\t\t\tdescriptor_length(byte):0x");
      resultBAT.append(Integer.toHexString(bat[12]));
      resultBAT.append("(");
      resultBAT.append(bat[12]);
      resultBAT.append(")");
      resultBAT.append("\n");
      resultBAT.append("\t\t\ttransport_stream_id:");
      resultBAT.append("0x0001");
      resultBAT.append("\n");
      resultBAT.append("\t\t\toriginal_network_id:");
      resultBAT.append("0x0001");
      resultBAT.append("\n");
      resultBAT.append("\t\t\tservice_id:");
      resultBAT.append("0x0001");
      resultBAT.append("\n");
      resultBAT.append("\t\t\tlinkage_type:");
      resultBAT.append("0x");
      resultBAT.append(Integer.toHexString(bat[19]));
      resultBAT.append("\n");
      resultBAT.append("\t\t\toui_data_length(byte):");
      resultBAT.append("0x");
      resultBAT.append(Integer.toHexString(bat[21]) + "(" + Integer.toHexString(bat[21]) + ")\n");
      StringBuffer buf1 = new StringBuffer();
      for (int j = 1; j < bat[21] + 1; j++)
        buf1.append(StringUtil.toHexStr(bat[21 + j], 2) + " "); 
      resultBAT.append("\t\t\toui_data(hex):" + buf1.toString() + "\n");
      resultBAT.append("\t\ttransport_stream_loop_length:0x");
      resultBAT.append(StringUtil.toHexStr(bat[70], 2) + "(" + StringUtil.toHexStr(bat[70], 2) + ")");
      resultBAT.append("\n");
      resultBAT.append("\t\tcrc_32:0x");
      resultBAT.append(StringUtil.toHexStr(bat[72], 2));
      resultBAT.append(StringUtil.toHexStr(bat[73], 2));
      resultBAT.append(StringUtil.toHexStr(bat[74], 2));
      resultBAT.append(StringUtil.toHexStr(bat[75], 2) + "\n\n");
      FileOutputStream outputStream = null;
      try {
        outputStream = new FileOutputStream(new File(fileName));
        outputStream.write(resultNIT.toString().getBytes(
              WorkbenchEncoding.getWorkbenchDefaultEncoding()));
        outputStream.write(resultBAT.toString().getBytes(
              WorkbenchEncoding.getWorkbenchDefaultEncoding()));
      } catch (IOException iOException) {
        try {
          if (outputStream != null)
            outputStream.close(); 
        } catch (IOException iOException1) {}
      } finally {
        try {
          if (outputStream != null)
            outputStream.close(); 
        } catch (IOException iOException) {}
      } 
    } 
  }
  
  public IStatus createPackage(List<UpgradeFileInfo> list, SsuUpgradeInfo info, SsuPackageOptions packageOtions, String strFilePathName, IProgressMonitor monitor) throws IOException, LoaderException {
    setIs32Bit(GlobleControler.intance.is32Bit());
    set64Bit(GlobleControler.intance.is64Bit());
    log("(SSU TS  package) is32Bit..." + is32Bit);
    log("(SSU TS  package) is64Bit..." + is64Bit);
    boolean needInsertEmptyOrDesc = (packageOtions.getInsertEmptyPacket() || packageOtions.getInsertLinkedDescriptorBtn());
    if (needInsertEmptyOrDesc) {
      this.symbolRate = packageOtions.getSymbolRate();
      this.validSymbolRate = packageOtions.getValidSymbolRate();
      this.transferMode = packageOtions.getTransferModeCombo();
      this.sectionNumber = getSectionNum(packageOtions);
      return createPackageOptions(list, info, packageOtions, strFilePathName, monitor);
    } 
    monitor.setTaskName("Validate upgrade file list..");
    boolean success = FileHelper.validateUpdateFilesList(list, 251658240L);
    if (!success)
      return Status.CANCEL_STATUS; 
    monitor.setTaskName("Analysis of the part file");
    list = FileHelper.getRealBurnFileList(list, 251658240L);
    if (256 < list.size())
      throw new LoaderException(String.format(Messages.LoaderComposite_MaxPartFile, new Object[] { Integer.valueOf(256) })); 
    monitor.beginTask("Packaged part files", 100 * list.size() + 20 + 20);
    setG_softwareVersion(info.getSoftwareVersion());
    setG_FactoryIdFlag(info.getManufacturerId());
    setG_HardwareVersion(info.getHardwareVersion());
    setG_start_sn(info.getStartSn());
    setG_end_sn(info.getEndSn());
    setG_struFrontend(new DbFrontEnd());
    getG_struFrontend().setU32Frequency(674000);
    getG_struFrontend().setU32SymbolRate(6875000);
    getG_struFrontend().setEnModulation(CableMode.valueOf(2));
    getG_struFrontend().setU16TsPID((short)info.getDownloadPid());
    getG_struFrontend().setU16GroupID((short)info.getDownloadGroupId());
    setG_u32GroupId(getG_struFrontend().getU16GroupID());
    monitor.worked(5);
    byte[] tsBuf = new byte[184];
    int lenDatagram = 0, lenPartInfo = 0, lenDownloadCtrl = 0;
    int pTempOffset = 0;
    HeadTsPacket strHeadTsPak = new HeadTsPacket();
    DSMCC_SectionInfo stDSISection = new DSMCC_SectionInfo();
    DSMCC_SectionInfo stDIISection = new DSMCC_SectionInfo();
    int dataGramIndex = 0;
    strHeadTsPak.setSynByte((byte)71);
    strHeadTsPak.setTransportErrorIndicator1((byte)0);
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    strHeadTsPak.setTransportPriority1((byte)0);
    strHeadTsPak.setTransportScramblingControl2((byte)0);
    strHeadTsPak.setAdaptationFieldControl2((byte)1);
    Arrays.fill(tsBuf, (byte)-1);
    RandomFileOutputStream fp = newOutputStream(strFilePathName);
    if (fp == null)
      return Status.CANCEL_STATUS; 
    try {
      monitor.worked(5);
      monitor.setTaskName("Compute all of part file crc");
      setG_struPartFile(fillFileDataStruct(list));
      setG_ulPartNum(getG_struPartFile().size());
      monitor.setTaskName("Package Part file..");
      if (monitor.isCanceled())
        return Status.CANCEL_STATUS; 
      monitor.worked(10);
      for (int partIndex = 0; partIndex < getG_ulPartNum(); partIndex++) {
        if (monitor.isCanceled())
          return Status.CANCEL_STATUS; 
        PartFile partFile = getG_struPartFile().get(partIndex);
        long[] values = { partFile.getSectionNum(), partFile.getLastDiagramDataLength(), partFile.getDatagramNum() };
        strHeadTsPak.setPid13(getG_struFrontend().getU16TsPID());
        monitor.worked(20);
        long u16DataGramNum = values[0];
        SubProgressMonitor subProgressMonitor = null;
      } 
    } finally {
      monitor.worked(20);
      try {
        fp.close();
      } catch (IOException e) {
        throw new LoaderException(Messages.TsPackageBuilder_CreateError);
      } 
    } 
    return Status.OK_STATUS;
  }
  
  private int getSectionNum(SsuPackageOptions packageOtions) {
    boolean needInsertEmptyAndDesc = (packageOtions.getInsertEmptyPacket() && packageOtions.getInsertLinkedDescriptorBtn());
    if (needInsertEmptyAndDesc) {
      this
        .sectionNumber = (this.symbolRate > this.validSymbolRate) ? (this.validSymbolRate * 257) : 100;
    } else if (packageOtions.getInsertLinkedDescriptorBtn()) {
      this.sectionNumber = (int)(this.symbolRate * 257.0D);
    } else if (packageOtions.getInsertEmptyPacket()) {
      this.sectionNumber = this.validSymbolRate * 257;
    } else {
      this.sectionNumber = 100;
    } 
    if (this.sectionNumber > 1000)
      this.sectionNumber /= 1000; 
    return this.sectionNumber;
  }
  
  static byte[] tempSectionData = new byte[4066];
  
  private static void loadingDDBSectionData(DDBSections stDDBSections, PartFile partFile, int partIndex, int dataGramIndex, long[] values) {
    long u32DataLen = 0L;
    int u32TotleLen = 0;
    short u8LastSectionNum = 0;
    long sectionNum = values[0];
    long lastSectionLength = values[1];
    int u16ModuleId = partFile.getModuleId();
    short u8ModuleVersion = (short)partFile.getModuleVersion();
    RandomAccessFile file = null;
    try {
      file = new RandomAccessFile(new File(partFile.getFileName()), "r");
      stDDBSections.newDSMCC_SectionInfo(1);
      stDDBSections.setU16SectionNum((short)(int)sectionNum);
      if (sectionNum > 256L) {
        u8LastSectionNum = 0;
      } else {
        u8LastSectionNum = (short)(int)sectionNum;
      } 
      DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
      construct_DDBSecHead(stDSMCCHeader, (short)60, u16ModuleId, (short)(dataGramIndex % 256), u8LastSectionNum);
      if (sectionNum - 1L == dataGramIndex) {
        u32DataLen = lastSectionLength;
      } else {
        u32DataLen = 4066L;
      } 
      int u16MsgLen = (int)(6L + u32DataLen);
      DSMCCMessageHeader stDsmccMsgHeader = new DSMCCMessageHeader();
      u32TotleLen = 9 + stDsmccMsgHeader.getSize() + u16MsgLen + 4;
      stDDBSections.getpDDBSection()[0] = new DSMCC_SectionInfo();
      stDDBSections.getpDDBSection()[0].setpSectionBuff(new byte[u32TotleLen]);
      memset(stDDBSections.getpDDBSection()[0].getpSectionBuff(), 0, u32TotleLen);
      stDDBSections.getpDDBSection()[0].setBuffLength((short)u32TotleLen);
      stDSMCCHeader
        .setSection_length12((short)(u32TotleLen - 1 - 3));
      byte[] ptmp = stDDBSections.getpDDBSection()[0].getpSectionBuff();
      construct_SecHead(stDSMCCHeader, ptmp);
      int offset = 0;
      offset += 9;
      construct_DSMCCMessageHeader(ptmp, 4099, u16ModuleId, u16MsgLen, offset);
      offset += stDsmccMsgHeader.getSize();
      offset = alterU16ToU8(ptmp, offset, (short)u16ModuleId);
      ptmp[offset++] = (byte)u8ModuleVersion;
      offset++;
      offset = alterU16ToU8(ptmp, offset, (short)dataGramIndex);
      long srcOffset = dataGramIndex * 4066L;
      file.seek(srcOffset);
      int read = file.read(tempSectionData, 0, (int)u32DataLen);
      System.arraycopy(tempSectionData, 0, ptmp, offset, read);
      offset += read;
      int crc = Crc32.compute(stDDBSections.getpDDBSection()[0].getpSectionBuff(), 1, u32TotleLen - 1 - 4);
      alterU32ToU8(ptmp, offset, crc);
      offset += 4;
    } catch (IOException iOException) {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException1) {}
    } finally {
      try {
        if (file != null)
          file.close(); 
      } catch (IOException iOException) {}
    } 
  }
  
  private static void construct_DIISection(DSMCC_SectionInfo pDIISection) {
    DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
    DSMCCMessageHeader stDsmccMsgHeader = new DSMCCMessageHeader();
    int u32CRClen = 4;
    int u32CrcVal = 0;
    int crcDataLen = 0;
    int messageLen = 0;
    int downloadId = 0;
    int totalLen = 0;
    short f = 0;
    ModuleDescription moduleDescription = new ModuleDescription();
    if (isIs32Bit()) {
      messageLen = 20 + getG_ulPartNum() * (moduleDescription.getSize() + 8 - 8) + 2;
    } else if (is64Bit()) {
      messageLen = 20 + getG_ulPartNum() * (moduleDescription.getSize() + 16) + 2;
    } else {
      messageLen = 20 + getG_ulPartNum() * (moduleDescription.getSize() + 16 - 8) + 2;
    } 
    if (is64Bit())
      for (f = 0; f < getG_ulPartNum(); f = (short)(f + 1)) {
        PartFile partFile = getG_struPartFile().get(f);
        String name = partFile.getPartitionName();
        if (name == null || name.isEmpty()) {
          messageLen += 4;
        } else {
          messageLen += 2 + name.length() + 2;
        } 
      }  
    totalLen = 9 + stDsmccMsgHeader.getSize() + messageLen + 4;
    pDIISection.setpSectionBuff(new byte[totalLen]);
    pDIISection.setBuffLength((short)totalLen);
    construct_DSIHead(stDSMCCHeader, 59, 0);
    stDSMCCHeader.setSection_length12((short)(totalLen - 1 - 3));
    byte[] pTmp = pDIISection.getpSectionBuff();
    construct_SecHead(stDSMCCHeader, pTmp);
    int offset = 0;
    offset += 9;
    construct_DSMCCMessageHeader(pTmp, 4098, 
        getG_u32GroupId(), messageLen, offset);
    offset += stDsmccMsgHeader.getSize();
    offset = alterU32ToU8(pTmp, offset, downloadId);
    offset = alterU16ToU8(pTmp, offset, (short)4066);
    offset += 12;
    int numberOfModules = getG_ulPartNum();
    offset = alterU16ToU8(pTmp, offset, (short)numberOfModules);
    for (f = 0; f < getG_ulPartNum(); f = (short)(f + 1)) {
      PartFile partFile = getG_struPartFile().get(f);
      ModuleDescription stModule = new ModuleDescription();
      stModule.setModuleId(partFile.getModuleId());
      stModule.setModuleSize(partFile.getFileSize());
      stModule.setModuleVersion(partFile.getModuleVersion());
      int partLength = 0;
      if (is64Bit()) {
        String name = partFile.getPartitionName();
        if (name == null || name.isEmpty()) {
          partLength += 4;
        } else {
          partLength += 2 + name.length() + 2;
          stModule.getModuleInfo().setPartitionName(name);
        } 
        stModule.getModuleInfo()
          .setPartitionVersion(partFile.getPartitionVersion());
        stModule.getModuleInfo()
          .setPartitionVerifyTag(partFile.getPartitionVerifyTag());
      } 
      if (isIs32Bit()) {
        stModule.setModuleInfoLength(
            (byte)(stModule.getModuleInfo().getSize() + 8 - 8 + partLength));
      } else if (is64Bit()) {
        stModule.setModuleInfoLength(
            (byte)(stModule.getModuleInfo().getSize() + 16 + partLength));
      } else {
        stModule.setModuleInfoLength(
            (byte)(stModule.getModuleInfo().getSize() + 16 - 8 + partLength));
      } 
      stModule.getModuleInfo().setFlashStartAddr(partFile.getBurnAddr());
      stModule.getModuleInfo()
        .setFlashEndAddr(partFile.getuPartitionEndAddr());
      stModule.getModuleInfo().setFlashType(partFile.getuFlashType()
          .ordinal());
      stModule.getModuleInfo().setFlashIndex(partFile.getlFlashIndex());
      stModule.getModuleInfo().setPartitionCRC(partFile.getCrcValue());
      int offsetlength = construct_ModuleDescription(stModule, pTmp, offset);
      if (is64Bit()) {
        offset = offsetlength;
      } else if (isIs32Bit()) {
        offset += stModule.getSize() + 8 - 8;
      } else {
        offset += stModule.getSize() + 16 - 8;
      } 
    } 
    int privateLength = 0;
    offset = alterU16ToU8(pTmp, offset, (short)privateLength);
    int crc = Crc32.compute(pDIISection.getpSectionBuff(), 1, totalLen - 1 - 4);
    alterU32ToU8(pTmp, offset, crc);
    offset += 4;
  }
  
  private static int construct_ModuleDescription(ModuleDescription pstModule, byte[] pTmp, int offset) {
    int descOffset = offset;
    descOffset = alterU16ToU8(pTmp, descOffset, pstModule
        .getModuleId());
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule.getModuleSize());
    pTmp[descOffset++] = pstModule.getModuleVersion();
    pTmp[descOffset++] = pstModule.getModuleInfoLength();
    if (isIs32Bit()) {
      descOffset = alterU32ToU8(pTmp, descOffset, 
          (int)pstModule.getModuleInfo().getFlashStartAddr());
      descOffset = alterU32ToU8(pTmp, descOffset, 
          (int)pstModule.getModuleInfo().getFlashEndAddr());
    } else {
      descOffset = alterU64ToU8(pTmp, descOffset, pstModule
          .getModuleInfo().getFlashStartAddr());
      descOffset = alterU64ToU8(pTmp, descOffset, pstModule
          .getModuleInfo().getFlashEndAddr());
    } 
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule
        .getModuleInfo().getFlashType());
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule
        .getModuleInfo().getFlashIndex());
    if (is64Bit()) {
      descOffset = alterU32ToU8(pTmp, descOffset, pstModule
          .getModuleInfo().getPartitionVersion());
      descOffset = alterU32LowToU8(pTmp, descOffset, pstModule
          .getModuleInfo().getPartitionVerifyTag());
      String name = pstModule.getModuleInfo().getPartitionName();
      if (name == null || name.isEmpty()) {
        descOffset = alterU16ToU8(pTmp, descOffset, (short)0);
        descOffset = alterU16ToU8(pTmp, descOffset, (short)0);
      } else {
        short len = (short)name.length();
        descOffset = alterU16ToU8(pTmp, descOffset, 
            (short)name.length());
        try {
          memcpy(pTmp, descOffset, name.getBytes(
                System.getProperty("file.encoding")), len);
        } catch (UnsupportedEncodingException unsupportedEncodingException) {}
        descOffset += len;
        descOffset = alterU16ToU8(pTmp, descOffset, (short)0);
      } 
    } 
    descOffset = alterU32ToU8(pTmp, descOffset, pstModule
        .getModuleInfo().getPartitionCRC());
    return descOffset;
  }
  
  private static RandomFileOutputStream newOutputStream(String strFilePathName) throws FileNotFoundException, LoaderException {
    FileUtil.deleteFile(strFilePathName);
    if (!FileUtil.canWriteFile(strFilePathName, Messages.TsPackageBuilder_CreateError))
      return null; 
    RandomFileOutputStream fp = null;
    try {
      fp = new RandomFileOutputStream(strFilePathName);
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    return fp;
  }
  
  public static void writeByte(byte[] src, int srcPos, byte[] dest, int destPos, int length) {
    System.arraycopy(src, srcPos, dest, destPos, length);
  }
  
  private static void construct_TsHead(byte[] out, HeadTsPacket pstrHeadTsPak, int destPos) throws LoaderException {
    byte[] headBuf = new byte[4];
    headBuf[0] = pstrHeadTsPak.getSynByte();
    headBuf[1] = 


      
      (byte)(0x0 | pstrHeadTsPak.getTransportErrorIndicator1() << 7 | pstrHeadTsPak.getPayloadUnitStartIndicator1() << 6 | pstrHeadTsPak.getTransportPriority1() << 5 | pstrHeadTsPak.getPid13() >>> 8 & 0x1F);
    headBuf[2] = (byte)(pstrHeadTsPak.getPid13() & 0xFF);
    headBuf[3] = 

      
      (byte)(0x0 | pstrHeadTsPak.getTransportScramblingControl2() << 6 | pstrHeadTsPak.getAdaptationFieldControl2() << 4 | pstrHeadTsPak.getContinuityCounter4());
    writeByte(headBuf, 0, out, destPos, headBuf.length);
  }
  
  private static int fillTsPackage(RandomFileOutputStream fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf, long pid) throws LoaderException, IOException {
    strHeadTsPak.setPid13((short)(int)pid);
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    try {
      construct_TsHead((OutputStream)fp, strHeadTsPak);
      strHeadTsPak.setPid13(getG_struFrontend().getU16TsPID());
      if (lenDownloadCtrl > 184) {
        while (lenDownloadCtrl > 184) {
          fp.write(pTmp, pTempOffset, 184);
          lenDownloadCtrl -= 184;
          strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
          if (count > 15)
            count = 0; 
          strHeadTsPak.setPayloadUnitStartIndicator1((byte)0);
          construct_TsHead((OutputStream)fp, strHeadTsPak);
          pTempOffset += 184;
        } 
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } else {
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } 
    } catch (IOException e) {
      closeStream(fp);
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    fflush(fp);
    return count;
  }
  
  private static int[] fillTsPackage(byte[] fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf) throws LoaderException, IOException {
    int oldLen = 0;
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    construct_TsHead(fp, strHeadTsPak, 0);
    pTempOffset += 4;
    if (lenDownloadCtrl > 184) {
      while (lenDownloadCtrl > 184) {
        writeByte(pTmp, oldLen, fp, pTempOffset, 184);
        lenDownloadCtrl -= 184;
        oldLen += 184;
        strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
        if (count > 15)
          count = 0; 
        if (strHeadTsPak.getPid13() != 8191)
          strHeadTsPak.setPayloadUnitStartIndicator1((byte)0); 
        pTempOffset += 184;
        construct_TsHead(fp, strHeadTsPak, pTempOffset);
        pTempOffset += 4;
      } 
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } else {
      writeByte(pTmp, oldLen, fp, pTempOffset, lenDownloadCtrl);
      pTempOffset += lenDownloadCtrl;
      writeByte(tsBuf, 0, fp, pTempOffset, 184 - lenDownloadCtrl);
      pTempOffset += 184 - lenDownloadCtrl;
    } 
    int[] temp = new int[2];
    temp[0] = count;
    temp[1] = pTempOffset;
    return temp;
  }
  
  private static int fillTsPackage(RandomFileOutputStream fp, HeadTsPacket strHeadTsPak, byte[] pTmp, int pTempOffset, int lenDownloadCtrl, int count, byte[] tsBuf) throws LoaderException, IOException {
    strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
    if (count > 15)
      count = 0; 
    strHeadTsPak.setPayloadUnitStartIndicator1((byte)1);
    try {
      construct_TsHead((OutputStream)fp, strHeadTsPak);
      if (lenDownloadCtrl > 184) {
        while (lenDownloadCtrl > 184) {
          fp.write(pTmp, pTempOffset, 184);
          lenDownloadCtrl -= 184;
          strHeadTsPak.setContinuityCounter4((byte)(count++ & 0xF));
          if (count > 15)
            count = 0; 
          strHeadTsPak.setPayloadUnitStartIndicator1((byte)0);
          construct_TsHead((OutputStream)fp, strHeadTsPak);
          pTempOffset += 184;
        } 
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } else {
        fp.write(pTmp, pTempOffset, lenDownloadCtrl);
        fp.write(tsBuf, 0, 184 - lenDownloadCtrl);
      } 
    } catch (IOException e) {
      closeStream(fp);
      throw new LoaderException(Messages.TsPackageBuilder_CreateError);
    } 
    fflush(fp);
    return count;
  }
  
  private static void fflush(RandomFileOutputStream fp) throws LoaderException {
    try {
      fp.flush();
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_CreateError + Messages.TsPackageBuilder_CreateError);
    } 
  }
  
  private static void closeStream(RandomFileOutputStream fp) {
    try {
      fp.close();
    } catch (IOException iOException) {}
  }
  
  private static void construct_DSMCCMessageHeader(byte[] pBuff, int msgId, int transactionId, int msgLen, int offset) {
    int descOffset = offset;
    DSMCCMessageHeader stMsgHeader = new DSMCCMessageHeader();
    stMsgHeader.setProtocolDiscriminator((byte)17);
    stMsgHeader.setDsmccType((byte)3);
    stMsgHeader.setMessageId((short)msgId);
    stMsgHeader.setTransactionId(transactionId);
    stMsgHeader.setReserved((byte)0);
    stMsgHeader.setAdapationLength((byte)0);
    stMsgHeader.setMessageLength((short)msgLen);
    pBuff[descOffset++] = stMsgHeader.getProtocolDiscriminator();
    pBuff[descOffset++] = stMsgHeader.getDsmccType();
    descOffset = alterU16ToU8(pBuff, descOffset, stMsgHeader
        .getMessageId());
    descOffset = alterU32ToU8(pBuff, descOffset, stMsgHeader
        .getTransactionId());
    pBuff[descOffset++] = stMsgHeader.getReserved();
    pBuff[descOffset++] = stMsgHeader.getAdapationLength();
    descOffset = alterU16ToU8(pBuff, descOffset, stMsgHeader
        .getMessageLength());
  }
  
  private static void memcpy(byte[] pu8Temp, int offset, byte[] downloadDescriptionString, short len) {
    System.arraycopy(downloadDescriptionString, 0, pu8Temp, offset, len);
  }
  
  private static void memset(byte[] buf, int value, int len) {
    assert buf.length == len;
    Arrays.fill(buf, (byte)value);
  }
  
  private static void construct_TsHead(OutputStream out, HeadTsPacket pstrHeadTsPak) throws LoaderException {
    byte[] headBuf = new byte[4];
    headBuf[0] = pstrHeadTsPak.getSynByte();
    headBuf[1] = 


      
      (byte)(0x0 | pstrHeadTsPak.getTransportErrorIndicator1() << 7 | pstrHeadTsPak.getPayloadUnitStartIndicator1() << 6 | pstrHeadTsPak.getTransportPriority1() << 5 | pstrHeadTsPak.getPid13() >>> 8 & 0x1F);
    headBuf[2] = (byte)(pstrHeadTsPak.getPid13() & 0xFF);
    headBuf[3] = 

      
      (byte)(0x0 | pstrHeadTsPak.getTransportScramblingControl2() << 6 | pstrHeadTsPak.getAdaptationFieldControl2() << 4 | pstrHeadTsPak.getContinuityCounter4());
    try {
      out.write(headBuf);
      out.flush();
    } catch (IOException e) {
      throw new LoaderException(Messages.TsPackageBuilder_FillError);
    } 
  }
  
  private static void construct_SecHead(DSMCCSectionHead pSecHead, byte[] secBuf) {
    secBuf[0] = 0;
    secBuf[1] = pSecHead.getTable_id();
    secBuf[2] = 
      (byte)(0x0 | pSecHead.getSection_syntax_indicator1() << 7 | 0x70 | (pSecHead.getSection_length12() & 0xF00) >> 8);
    secBuf[3] = (byte)(pSecHead.getSection_length12() & 0xFF);
    secBuf[4] = (byte)((pSecHead.getTable_id_extension() & 0xFF00) >> 8);
    secBuf[5] = (byte)(pSecHead.getTable_id_extension() & 0xFF);
    secBuf[6] = 
      (byte)((pSecHead.getVersion_number5() & 0x1F) << 2 | pSecHead.getCurrent_next_indicator1());
    secBuf[7] = pSecHead.getSection_number();
    secBuf[8] = pSecHead.getLast_section_number();
  }
  
  private static int alterU64ToU8(byte[] pu8Data, int offset, long u64Data) {
    pu8Data[offset] = (byte)(int)(u64Data >> 56L & 0xFFL);
    pu8Data[offset + 1] = (byte)(int)(u64Data >> 48L & 0xFFL);
    pu8Data[offset + 2] = (byte)(int)(u64Data >> 40L & 0xFFL);
    pu8Data[offset + 3] = (byte)(int)(u64Data >> 32L & 0xFFL);
    pu8Data[offset + 4] = (byte)(int)(u64Data >> 24L & 0xFFL);
    pu8Data[offset + 5] = (byte)(int)(u64Data >> 16L & 0xFFL);
    pu8Data[offset + 6] = (byte)(int)(u64Data >> 8L & 0xFFL);
    pu8Data[offset + 7] = (byte)(int)(u64Data & 0xFFL);
    offset += 8;
    return offset;
  }
  
  private static int alterU32ToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF000000) >>> 24);
    pu8Data[offset + 1] = (byte)((u32Data & 0xFF0000) >>> 16);
    pu8Data[offset + 2] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 3] = (byte)(u32Data & 0xFF);
    return offset + 4;
  }
  
  private static int alterU32ToU8(byte[] pu8Data, int offset, long u32Data) {
    pu8Data[offset] = (byte)(int)((u32Data & 0xFFFFFFFFFF000000L) >>> 24L);
    pu8Data[offset + 1] = (byte)(int)((u32Data & 0xFF0000L) >>> 16L);
    pu8Data[offset + 2] = (byte)(int)((u32Data & 0xFF00L) >>> 8L);
    pu8Data[offset + 3] = (byte)(int)(u32Data & 0xFFL);
    return offset + 4;
  }
  
  public static int alterU12ToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF00) >>> 4 & 0xFF);
    pu8Data[offset + 1] = (byte)(u32Data & 0xFF);
    return offset + 2;
  }
  
  public static int alterU16ToU8(byte[] pu8Data, int offset, short u4Data, short u12Data) {
    pu8Data[offset] = (byte)(((u4Data & 0xFF) << 4) + (u12Data & 0xFF));
    pu8Data[offset + 1] = 0;
    return offset + 2;
  }
  
  private static int alterU16BitToU8(byte[] pu8Data, int offset, short u32Data, String data, short cableModulation) {
    int[] result = getIntData(data);
    pu8Data[offset] = (byte)(((cableModulation & 0xFF) << 4) + result[0]);
    pu8Data[offset + 1] = (byte)(((result[2] & 0xFF) << 4) + result[3]);
    return offset + 2;
  }
  
  private static int alterU16BitToU8(byte[] pu8Data, int offset, short u32Data, String data) {
    int[] result = getIntData(data);
    pu8Data[offset] = (byte)(((result[0] & 0xFF) << 4) + result[1]);
    pu8Data[offset + 1] = (byte)(((result[2] & 0xFF) << 4) + result[3]);
    return offset + 2;
  }
  
  private static int[] getIntData(String data) {
    int[] result = new int[4];
    if (data.length() > 0)
      if (data.length() == 4) {
        result[0] = Integer.parseInt(data.substring(0, 1));
        result[1] = Integer.parseInt(data.substring(1, 2));
        result[2] = Integer.parseInt(data.substring(2, 3));
        result[3] = Integer.parseInt(data.substring(3, 4));
      } else if (data.length() == 3) {
        result[1] = Integer.parseInt(data.substring(0, 1));
        result[2] = Integer.parseInt(data.substring(1, 2));
        result[3] = Integer.parseInt(data.substring(2, 3));
      } else if (data.length() == 2) {
        result[2] = Integer.parseInt(data.substring(0, 1));
        result[3] = Integer.parseInt(data.substring(1, 2));
      } else if (data.length() == 1) {
        result[3] = Integer.parseInt(data);
      }  
    return result;
  }
  
  private static int alterU16ByModulationToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF) << 4);
    return offset + 2;
  }
  
  private static int alterU16ToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 1] = (byte)(u32Data & 0xFF);
    return offset + 2;
  }
  
  private static int alterU8ToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)(u32Data & 0xFF00);
    return offset + 1;
  }
  
  private static int alterU8ToU8(byte[] pTmp, int offset, int code_rate_LP_stream, int guard_interval, int transmission_mode, int other_frequency_flag) {
    pTmp[offset++] = (byte)((code_rate_LP_stream << 5) + (guard_interval << 3) + (transmission_mode << 1) + other_frequency_flag & 0xFF);
    return offset;
  }
  
  private static int alterU4ToU8(byte[] pTmp, int offset, int code_rate_LP_stream) {
    pTmp[offset++] = (byte)(code_rate_LP_stream << 4 & 0xFF);
    return offset;
  }
  
  private static int alterU16ToU8(byte[] pTmp, int offset, int bandwidth, int reserved_future_use, int constellation, int hierarchy_information, int code_rate_HP_stream) {
    pTmp[offset] = (byte)((bandwidth << 5) + (reserved_future_use << 1) + (constellation >>> 2) & 0xFF);
    pTmp[offset + 1] = (byte)(((constellation & 0x3) << 6) + (hierarchy_information << 3) + code_rate_HP_stream & 0xFF);
    return offset + 2;
  }
  
  private static int alterU24ToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF0000) >>> 16);
    pu8Data[offset + 1] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 2] = (byte)(u32Data & 0xFF);
    return offset + 3;
  }
  
  private static int alterU28ToU8(byte[] pu8Data, int offset, short u32Data) {
    pu8Data[offset] = (byte)((u32Data & 0xFF0000) >>> 16);
    pu8Data[offset + 1] = (byte)((u32Data & 0xFF00) >>> 8);
    pu8Data[offset + 2] = (byte)(u32Data & 0xFF);
    return offset + 3;
  }
  
  private static void construct_DDBSecHead(DSMCCSectionHead stDSMCCHeader, short ddbTableId, int u16TableExId, short u8SectionNum, short last_section_number) {
    stDSMCCHeader.setTable_id((byte)ddbTableId);
    stDSMCCHeader.setSection_syntax_indicator1((byte)1);
    stDSMCCHeader.setTable_id_extension((short)u16TableExId);
    stDSMCCHeader.setCurrent_next_indicator1((byte)1);
    stDSMCCHeader.setVersion_number5((byte)0);
    stDSMCCHeader.setSection_number((byte)u8SectionNum);
    stDSMCCHeader.setLast_section_number((byte)last_section_number);
  }
  
  private static void construct_NULLSection(DSMCC_SectionInfo stNULLSection) {
    stNULLSection.setpSectionBuff(new byte[4096]);
    stNULLSection.setBuffLength((short)4066);
    Arrays.fill(stNULLSection.getpSectionBuff(), (byte)-1);
  }
  
  private static void construct_NitSection(DSMCC_SectionInfo pDSISection, SsuUpgradeInfo info, SsuPackageOptions packageOtions) {
    int delivery_flag = packageOtions.getTransferModeCombo();
    long centre_frequency = packageOtions.getCentreFrequency();
    int bandwidth = packageOtions.getBandWidth();
    int constellation = packageOtions.getConstellation();
    int upgradeType = packageOtions.getUpgradeTypeCombo();
    double cableFrequency = packageOtions.getCableFrequency();
    int cableModulation = packageOtions.getCableModulation();
    int cableSymbolRate = packageOtions.getSymbolRate();
    if (delivery_flag == 1) {
      delivery_flag = 3;
    } else if (delivery_flag == 0) {
      delivery_flag = 1;
    } 
    pDSISection.setpSectionBuff(new byte[1024]);
    pDSISection.setBuffLength((short)0);
    DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
    int u32CrcVal = 0;
    int crcDataLen = 0;
    int messageLen = 0;
    int sectionLength = 0;
    pDSISection.setpSectionBuff(new byte[1024]);
    pDSISection.setBuffLength((short)0);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 8 + 1));
    byte[] pTmp = pDSISection.getpSectionBuff();
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 2));
    int linkageOffset = pDSISection.getBuffLength();
    pTmp[linkageOffset++] = 74;
    pTmp[linkageOffset++] = 57;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1);
    pTmp[linkageOffset++] = 9;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)48);
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, info.getManufacturerId() & 0xFFFFFF);
    pTmp[linkageOffset++] = 44;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, 
        (short)info.getDownloadPid());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getHardwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getSoftwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getStartSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getEndSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU4ToU8(pTmp, linkageOffset, upgradeType);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, (short)0);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, (short)0);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, (short)0);
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    pTmp[linkageOffset++] = (byte)delivery_flag;
    if (delivery_flag == 1) {
      linkageOffset = createCable(cableFrequency, cableModulation, cableSymbolRate, pTmp, linkageOffset);
    } else if (delivery_flag == 3) {
      linkageOffset = createTerrestrial(centre_frequency, bandwidth, constellation, pTmp, linkageOffset);
    } 
    messageLen = linkageOffset - 11;
    int netWork_descriptors_length_index = 9;
    alterU12ToU8(pTmp, netWork_descriptors_length_index, (short)messageLen);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + messageLen));
    int transport_stram_loop_length_index = pDSISection.getBuffLength();
    int transport_stram_loop_length = 0;
    alterU16ToU8(pTmp, transport_stram_loop_length_index, (short)transport_stram_loop_length);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 2));
    sectionLength = pDSISection.getBuffLength();
    stDSMCCHeader.setSection_length12((short)sectionLength);
    construct_NITHead(stDSMCCHeader, 64, 1);
    construct_SecHead(stDSMCCHeader, pDSISection.getpSectionBuff());
    crcDataLen = pDSISection.getBuffLength();
    u32CrcVal = Crc32.compute(pDSISection.getpSectionBuff(), 1, crcDataLen - 1);
    alterU32ToU8(pDSISection.getpSectionBuff(), crcDataLen, u32CrcVal);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 4));
  }
  
  private static int createCable(double cableFrequency, int cableModulation, int cableSymbolRate, byte[] pTmp, int linkageOffset) {
    short temp = 0;
    pTmp[linkageOffset++] = 68;
    pTmp[linkageOffset++] = 11;
    String frequency = String.valueOf(cableFrequency);
    if (frequency.indexOf(".") > 0) {
      String[] result = frequency.split("\\.");
      Short frequencyResult = Short.valueOf(Short.parseShort(result[0]));
      if (frequencyResult.shortValue() > 0) {
        linkageOffset = alterU16BitToU8(pTmp, linkageOffset, frequencyResult
            .shortValue(), result[0]);
      } else {
        linkageOffset = alterU16ToU8(pTmp, linkageOffset, temp);
      } 
      Short frequencyResult1 = Short.valueOf(Short.parseShort(result[1]));
      if (frequencyResult1.shortValue() > 0) {
        linkageOffset = alterU16BitToU8(pTmp, linkageOffset, frequencyResult1
            .shortValue(), result[1]);
      } else {
        linkageOffset = alterU16ToU8(pTmp, linkageOffset, temp);
      } 
    } else {
      linkageOffset = alterU32ToU8(pTmp, linkageOffset, (int)cableFrequency);
    } 
    String symbolRate = String.valueOf(cableSymbolRate);
    int length = symbolRate.length();
    if (length > 3) {
      String result1Str = null;
      String result2Str = null;
      if (length == 4) {
        result1Str = symbolRate.substring(1, 4);
        result2Str = symbolRate.substring(0, 1);
      } else if (length == 5) {
        result1Str = symbolRate.substring(2, 5);
        result2Str = symbolRate.substring(0, 2);
      } 
      if (result2Str != null) {
        Short result2 = Short.valueOf(Short.parseShort(result2Str));
        if (result2.shortValue() > 0) {
          linkageOffset = alterU16BitToU8(pTmp, linkageOffset, result2
              .shortValue(), result2Str, (short)cableModulation);
        } else {
          linkageOffset = alterU16ByModulationToU8(pTmp, linkageOffset, (short)cableModulation);
        } 
      } 
      if (result1Str != null) {
        Short result1 = Short.valueOf(Short.parseShort(result1Str));
        if (result1.shortValue() > 0) {
          result1 = Short.valueOf((short)(result1.shortValue() * 10));
          result1Str = result1Str + "0";
          linkageOffset = alterU16BitToU8(pTmp, linkageOffset, result1
              .shortValue(), result1Str);
        } else {
          linkageOffset = alterU16ToU8(pTmp, linkageOffset, temp);
        } 
      } 
    } else {
      linkageOffset = alterU16ByModulationToU8(pTmp, linkageOffset, (short)cableModulation);
      Short result1 = Short.valueOf(Short.parseShort(symbolRate));
      if (result1.shortValue() > 0) {
        result1 = Short.valueOf((short)(result1.shortValue() * 10));
        symbolRate = symbolRate + "0";
        linkageOffset = alterU16BitToU8(pTmp, linkageOffset, result1.shortValue(), symbolRate);
      } else {
        linkageOffset = alterU16ToU8(pTmp, linkageOffset, temp);
      } 
    } 
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, temp);
    return linkageOffset;
  }
  
  private static int createTerrestrial(long centre_frequency, int bandwidth, int constellation, byte[] pTmp, int linkageOffset) {
    pTmp[linkageOffset++] = 90;
    pTmp[linkageOffset++] = 11;
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, centre_frequency);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, bandwidth, 0, constellation, 1, 1);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, 1, 2, 2, 1);
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    return linkageOffset;
  }
  
  private void construct_BatSection(DSMCC_SectionInfo pDSISection, SsuUpgradeInfo info, SsuPackageOptions packageOtions) {
    int delivery_flag = packageOtions.getTransferModeCombo();
    long centre_frequency = packageOtions.getCentreFrequency();
    int bandwidth = packageOtions.getBandWidth();
    int constellation = packageOtions.getConstellation();
    int upgradeType = packageOtions.getUpgradeTypeCombo();
    double cableFrequency = packageOtions.getCableFrequency();
    int cableModulation = packageOtions.getCableModulation();
    int cableSymbolRate = packageOtions.getSymbolRate();
    if (delivery_flag == 1) {
      delivery_flag = 3;
    } else if (delivery_flag == 0) {
      delivery_flag = 1;
    } 
    pDSISection.setpSectionBuff(new byte[1024]);
    pDSISection.setBuffLength((short)0);
    DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
    int u32CrcVal = 0;
    int crcDataLen = 0;
    int messageLen = 0;
    pDSISection.setpSectionBuff(new byte[1024]);
    pDSISection.setBuffLength((short)0);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 8 + 1));
    byte[] pTmp = pDSISection.getpSectionBuff();
    int offset = pDSISection.getBuffLength();
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 2));
    int linkageOffset = pDSISection.getBuffLength();
    pTmp[linkageOffset++] = 74;
    pTmp[linkageOffset++] = 57;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1);
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)1);
    pTmp[linkageOffset++] = 9;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, (short)48);
    linkageOffset = alterU24ToU8(pTmp, linkageOffset, info.getManufacturerId() & 0xFFFFFF);
    pTmp[linkageOffset++] = 44;
    linkageOffset = alterU16ToU8(pTmp, linkageOffset, 
        (short)info.getDownloadPid());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getHardwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getSoftwareVersion());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getStartSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, info
        .getEndSn());
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    linkageOffset = alterU4ToU8(pTmp, linkageOffset, upgradeType);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, (short)0);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, (short)0);
    linkageOffset = alterU8ToU8(pTmp, linkageOffset, (short)0);
    linkageOffset = alterU32ToU8(pTmp, linkageOffset, 0);
    pTmp[linkageOffset++] = (byte)delivery_flag;
    if (delivery_flag == 1) {
      linkageOffset = createCable(cableFrequency, cableModulation, cableSymbolRate, pTmp, linkageOffset);
    } else if (delivery_flag == 3) {
      linkageOffset = createTerrestrial(centre_frequency, bandwidth, constellation, pTmp, linkageOffset);
    } 
    messageLen = linkageOffset - 11;
    int netWork_descriptors_length_index = 9;
    alterU12ToU8(pTmp, netWork_descriptors_length_index, (short)messageLen);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + messageLen));
    int transport_stram_loop_length_index = pDSISection.getBuffLength();
    int transport_stram_loop_length = 0;
    alterU16ToU8(pTmp, transport_stram_loop_length_index, (short)transport_stram_loop_length);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 2));
    offset = pDSISection.getBuffLength();
    stDSMCCHeader.setSection_length12((short)offset);
    construct_NITHead(stDSMCCHeader, 74, 0);
    construct_SecHead(stDSMCCHeader, pDSISection.getpSectionBuff());
    crcDataLen = pDSISection.getBuffLength();
    u32CrcVal = Crc32.compute(pDSISection.getpSectionBuff(), 1, crcDataLen - 1);
    alterU32ToU8(pDSISection.getpSectionBuff(), crcDataLen, u32CrcVal);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 4));
  }
  
  private static void construct_DSISection(DSMCC_SectionInfo pDSISection) {
    DSMCCSectionHead stDSMCCHeader = new DSMCCSectionHead();
    DSMCCMessageHeader stDsmccMsgHeader = new DSMCCMessageHeader();
    int u32CrcVal = 0;
    int crcDataLen = 0;
    byte[] serviceId = new byte[20];
    int privateLength = 0;
    pDSISection.setpSectionBuff(new byte[1024]);
    pDSISection.setBuffLength((short)0);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 8 + 1));
    pDSISection.setBuffLength(
        (short)(pDSISection.getBuffLength() + stDsmccMsgHeader.getSize()));
    memset(serviceId, 255, serviceId.length);
    memcpy(pDSISection.getpSectionBuff(), pDSISection.getBuffLength(), serviceId, (short)serviceId.length);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + serviceId.length));
    byte[] pTmp = pDSISection.getpSectionBuff();
    int offset = pDSISection.getBuffLength();
    int outCompatibility = 0;
    alterU16ToU8(pTmp, offset, (short)outCompatibility);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 2));
    offset = pDSISection.getBuffLength() + 2;
    privateLength = construct_GroupInfoIndication(pTmp, offset, privateLength);
    offset = pDSISection.getBuffLength();
    alterU16ToU8(pTmp, offset, (short)privateLength);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + privateLength + 2));
    int messageLen = privateLength + serviceId.length + 2 + 2;
    offset = 9;
    construct_DSMCCMessageHeader(pTmp, 4102, 0, messageLen, offset);
    stDSMCCHeader.setSection_length12(
        (short)(5 + stDsmccMsgHeader.getSize() + messageLen + 4));
    construct_DSIHead(stDSMCCHeader, 59, 0);
    construct_SecHead(stDSMCCHeader, pDSISection.getpSectionBuff());
    crcDataLen = stDSMCCHeader.getSection_length12() + 3 - 4;
    u32CrcVal = Crc32.compute(pDSISection.getpSectionBuff(), 1, crcDataLen);
    alterU32ToU8(pDSISection.getpSectionBuff(), 1 + crcDataLen, u32CrcVal);
    pDSISection.setBuffLength((short)(pDSISection.getBuffLength() + 4));
  }
  
  private static void construct_BATTHead(DSMCCSectionHead pSectionHead, int tableID, int tableIdExt) {
    pSectionHead.setTable_id((byte)tableID);
    pSectionHead.setSection_syntax_indicator1((byte)1);
    pSectionHead.setPrivate_indicator1((byte)0);
    pSectionHead.setReserved2((byte)0);
    pSectionHead.setTable_id_extension((short)tableIdExt);
    pSectionHead.setReserved_2((byte)0);
    pSectionHead.setVersion_number5((byte)0);
    pSectionHead.setCurrent_next_indicator1((byte)0);
    pSectionHead.setSection_number((byte)0);
    pSectionHead.setLast_section_number((byte)0);
  }
  
  private static void construct_NITHead(DSMCCSectionHead pSectionHead, int tableID, int tableIdExt) {
    pSectionHead.setTable_id((byte)tableID);
    pSectionHead.setSection_syntax_indicator1((byte)1);
    pSectionHead.setPrivate_indicator1((byte)0);
    pSectionHead.setReserved2((byte)0);
    pSectionHead.setTable_id_extension((short)tableIdExt);
    pSectionHead.setReserved_2((byte)0);
    pSectionHead.setVersion_number5((byte)0);
    pSectionHead.setCurrent_next_indicator1((byte)1);
    pSectionHead.setSection_number((byte)0);
    pSectionHead.setLast_section_number((byte)0);
  }
  
  private static void construct_DSIHead(DSMCCSectionHead pSectionHead, int tableID, int tableIdExt) {
    pSectionHead.setTable_id((byte)tableID);
    pSectionHead.setSection_syntax_indicator1((byte)1);
    pSectionHead.setTable_id_extension((short)tableIdExt);
    pSectionHead.setVersion_number5((byte)0);
    pSectionHead.setCurrent_next_indicator1((byte)1);
    pSectionHead.setSection_number((byte)0);
    pSectionHead.setLast_section_number((byte)1);
  }
  
  static SubCompatibilityDescriptor subCompatibilityDescriptor = new SubCompatibilityDescriptor();
  
  private static int construct_GroupInfoIndication(byte[] pBuff, int offset, int pLen) {
    short f = 0;
    int descOffset = offset;
    GroupInfoIndication stGII = new GroupInfoIndication();
    int descpLen = 0;
    stGII.setNumberOfGroup((short)1);
    descOffset = alterU16ToU8(pBuff, descOffset, stGII
        .getNumberOfGroup());
    descpLen += 2;
    for (f = 0; f < stGII.getNumberOfGroup(); f = (short)(f + 1)) {
      stGII.getGroupDescription()[f] = new GroupDescription();
      stGII.getGroupDescription()[f].setGroupId(getG_u32GroupId());
      stGII.getGroupDescription()[f].setGroupSize(g_u32DataTotalLen);
      descOffset = alterU32ToU8(pBuff, descOffset, stGII
          .getGroupDescription()[f].getGroupId());
      if (is64Bit()) {
        descOffset = alterU32ToU8(pBuff, descOffset, 
            (int)stGII.getGroupDescription()[f].getGroupSize());
        descpLen += 8;
      } else if (isIs32Bit()) {
        descOffset = alterU32ToU8(pBuff, descOffset, 
            (int)stGII.getGroupDescription()[f].getGroupSize());
        descpLen += 8;
      } else {
        descOffset = alterU64ToU8(pBuff, descOffset, stGII
            .getGroupDescription()[f].getGroupSize());
        descpLen += 12;
      } 
      CompatibilityDescriptor pstCompDes = stGII.getGroupDescription()[f].getGroupCompatibility();
      pstCompDes.setDescriptorCount((short)4);
      pstCompDes
        .setCompatibilityDescriptorLength(
          (short)((subCompatibilityDescriptor.getSize() - 4) * pstCompDes.getDescriptorCount() + 2));
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getCompatibilityDescriptorLength());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptorCount());
      descpLen += 4;
      pstCompDes.getDescriptor()[0] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[0]
        .setDescriptorType((byte)1);
      pstCompDes.getDescriptor()[0].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[0].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[0]
        .setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFL));
      pstCompDes.getDescriptor()[0]
        .setModel((short)(int)((getG_HardwareVersion() & 0xFFFFFFFFFFFF0000L) >>> 16L));
      pstCompDes.getDescriptor()[0]
        .setVersion((short)(int)(getG_HardwareVersion() & 0xFFFFL));
      pstCompDes.getDescriptor()[0].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[0]
        .getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[0]
        .getDescriptorLength();
      pBuff[descOffset++] = 
        (byte)pstCompDes.getDescriptor()[0].getSpecifierType();
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[0].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[0].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = 
        (byte)(pstCompDes.getDescriptor()[0].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[0].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[0].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[0]
        .getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      pstCompDes.getDescriptor()[1] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[1]
        .setDescriptorType((byte)2);
      pstCompDes.getDescriptor()[1].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[1].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[1]
        .setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFFFFFL));
      pstCompDes.getDescriptor()[1]
        .setModel((short)(int)((getG_softwareVersion() & 0xFFFFFFFFFFFF0000L) >>> 16L));
      pstCompDes.getDescriptor()[1]
        .setVersion((short)(int)(getG_softwareVersion() & 0xFFFFL));
      pstCompDes.getDescriptor()[1].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[1]
        .getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[1]
        .getDescriptorLength();
      pBuff[descOffset++] = 
        (byte)pstCompDes.getDescriptor()[1].getSpecifierType();
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[1].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[1].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = 
        (byte)(pstCompDes.getDescriptor()[1].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[1].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[1].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[1]
        .getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      pstCompDes.getDescriptor()[2] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[2]
        .setDescriptorType((byte)64);
      pstCompDes.getDescriptor()[2].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[2].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[2]
        .setSpecifierData((int)(getG_FactoryIdFlag() & 0xFFFFFFL));
      pstCompDes.getDescriptor()[2]
        .setModel((short)(int)((getG_start_sn() & 0xFFFFFFFFFFFF0000L) >>> 16L));
      pstCompDes.getDescriptor()[2]
        .setVersion((short)(int)(getG_start_sn() & 0xFFFFL));
      pstCompDes.getDescriptor()[2].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[2]
        .getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[2]
        .getDescriptorLength();
      pBuff[descOffset++] = 
        (byte)pstCompDes.getDescriptor()[2].getSpecifierType();
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[2].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[2].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = 
        (byte)(pstCompDes.getDescriptor()[2].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[2].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[2].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[2]
        .getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      pstCompDes.getDescriptor()[3] = new SubCompatibilityDescriptor();
      pstCompDes.getDescriptor()[3]
        .setDescriptorType((byte)65);
      pstCompDes.getDescriptor()[3].setDescriptorLength((byte)9);
      pstCompDes.getDescriptor()[3].setSpecifierType((byte)1);
      pstCompDes.getDescriptor()[3]
        .setSpecifierData((int)getG_FactoryIdFlag() & 0xFFFFFF);
      pstCompDes.getDescriptor()[3]
        .setModel((short)(int)((getG_end_sn() & 0xFFFFFFFFFFFF0000L) >>> 16L));
      pstCompDes.getDescriptor()[3]
        .setVersion((short)(int)(getG_end_sn() & 0xFFFFL));
      pstCompDes.getDescriptor()[3].setSubDescriptorCount((byte)0);
      pBuff[descOffset++] = pstCompDes.getDescriptor()[3]
        .getDescriptorType();
      pBuff[descOffset++] = pstCompDes.getDescriptor()[3]
        .getDescriptorLength();
      pBuff[descOffset++] = 
        (byte)pstCompDes.getDescriptor()[3].getSpecifierType();
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[3].getSpecifierData() & 0xFF0000) >>> 16);
      pBuff[descOffset++] = 
        (byte)((pstCompDes.getDescriptor()[3].getSpecifierData() & 0xFF00) >>> 8);
      pBuff[descOffset++] = 
        (byte)(pstCompDes.getDescriptor()[3].getSpecifierData() & 0xFF);
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[3].getModel());
      descOffset = alterU16ToU8(pBuff, descOffset, pstCompDes
          .getDescriptor()[3].getVersion());
      pBuff[descOffset++] = pstCompDes.getDescriptor()[3]
        .getSubDescriptorCount();
      descpLen += subCompatibilityDescriptor.getSize() - 4;
      stGII.getGroupDescription()[f].setGoupInfoLength((short)0);
      descOffset = alterU16ToU8(pBuff, descOffset, stGII
          .getGroupDescription()[f].getGoupInfoLength());
      descpLen += 2;
      stGII.getGroupDescription()[f].setPrivateLength((short)0);
      descOffset = alterU16ToU8(pBuff, descOffset, stGII
          .getGroupDescription()[f].getPrivateLength());
      descpLen += 2;
    } 
    return descpLen;
  }
  
  private static int alterU32LowToU8(byte[] pu8Data, int offset, int u32Data) {
    pu8Data[offset] = 0;
    pu8Data[offset + 1] = 0;
    pu8Data[offset + 2] = 0;
    pu8Data[offset + 3] = (byte)(u32Data & 0xFF);
    return offset + 4;
  }
  
  public static void memcpy(byte[] pTmp, int offset, String string, long len) {
    if (len > string.length())
      len = string.length(); 
    for (int i = 0; i < len; i++)
      pTmp[offset++] = (byte)string.charAt(i); 
  }
  
  private static List<PartFile> fillFileDataStruct(List<UpgradeFileInfo> files) {
    long u32DatagramNum = 0L;
    g_u32DataTotalLen = 0L;
    g_u32DataCrc = -1;
    List<PartFile> headers = new ArrayList<>(files.size());
    for (int i = 0; i < files.size(); i++) {
      PartFile partFile = new PartFile();
      headers.add(partFile);
      partFile.init(files.get(i), getG_u32GroupId(), i);
      long fileLength = (new File(partFile.getFileName())).length();
      g_u32DataTotalLen += (new File(partFile.getFileName())).length();
      long lastSectionLength = 4066L;
      u32DatagramNum = fileLength / 4066L;
      if (0L != fileLength % 4066L) {
        lastSectionLength = fileLength % 4066L;
        u32DatagramNum++;
      } 
      partFile.setDatagramNum((int)u32DatagramNum);
      partFile.setLastDiagramDataLength(lastSectionLength);
      partFile.setSectionNum(u32DatagramNum);
      try {
        int[] crc = Crc32.compute(partFile.getFileName(), g_u32DataCrc);
        partFile.setCrcValue(crc[0]);
        g_u32DataCrc = crc[1];
      } catch (IOException iOException) {}
    } 
    return headers;
  }
  
  public IStatus createPackage(List<UpgradeFileInfo> fileInfoList, UpgradeInfo info, String tsFileName, IProgressMonitor monitor) throws IOException, LoaderException {
    return null;
  }
  
  private static void log(String infoStr) {
    if (PropertiesUtility.isCmdLine())
      Log.println(infoStr); 
  }
}
